Codeforces 950C-Zebras(模拟构造)

题目链接:https://codeforces.com/problemset/problem/950/C
博客园食用链接:https://www.cnblogs.com/lonely-wind-/p/13453216.html

Oleg writes down the history of the days he lived. For each day he decides if it was good or bad. Oleg calls a non-empty sequence of days a zebra, if it starts with a bad day, ends with a bad day, and good and bad days are alternating in it. Let us denote bad days as 0 and good days as 1. Then, for example, sequences of days 0, 010, 01010 are zebras, while sequences 1, 0110, 0101 are not.

Oleg tells you the story of days he lived in chronological order in form of string consisting of 0 and 1. Now you are interested if it is possible to divide Oleg’s life history into several subsequences, each of which is a zebra, and the way it can be done. Each day must belong to exactly one of the subsequences. For each of the subsequences, days forming it must be ordered chronologically. Note that subsequence does not have to be a group of consecutive days.

Input
In the only line of input data there is a non-empty string s consisting of characters 0 and 1, which describes the history of Oleg’s life. Its length (denoted as |s|) does not exceed 200 000 characters.

Output
If there is a way to divide history into zebra subsequences, in the first line of output you should print an integer k ( 1   ≤   k   ≤   ∣ s ∣ ) k (1 ≤ k ≤ |s|) k(1ks), the resulting number of subsequences. In the i-th of following k lines first print the integer l i ( 1   ≤   l i   ≤   ∣ s ∣ ) l _i (1 ≤ l _i ≤ |s|) li(1lis), which is the length of the i-th subsequence, and then l i indices of days forming the subsequence. Indices must follow in ascending order. Days are numbered starting from 1. Each index from 1 to n must belong to exactly one subsequence. If there is no way to divide day history into zebra subsequences, print -1.

Subsequences may be printed in any order. If there are several solutions, you may print any of them. You do not have to minimize nor maximize the value of k.

Examples
Input
0010100
Output
3
3 1 3 4
3 2 5 6
1 7

Input
111
Output
-1

题目大意:给你一个序列,问你能否将其拆分为若干个斑马序列,若能请输出其拆分方法,否则输出-1,斑马序列的定义如下:开头是0,结尾是0,整个序列是01交替的,当然单个的0也是合法的。

emmm,不要想太多了,直接按照题目要求的来构造就行了,我们知道,1一定要放在0后面的,0也一定要放在1后面的(如果有1的话),然后多出来的0就单独成一段。

那么就可以用 v e c t o r < i n t > g [ m a x n ] vector<int>g[maxn] vector<int>g[maxn]来保存序列,假设现在的序列个数已经跟新到了第 c n t cnt cnt个,那么每次出现0的时候我们查询是否在 g [ 1 − c n t ] g[1-cnt] g[1cnt]中是否有以1为结尾的,如果有我们就直接接上去,如果没有就单独开创,同时 c n t + + cnt++ cnt++,如果出现的是1,那么我们出现之前是否有以0为结尾的,如果有就接上去,没有就直接-1了。

现在有个问题就是怎么快速地查询这些以01为结尾的编号,如果for一遍的话时间复杂度有点高,所以我们可以用两个队列来保存这些编号,每次都将队首给弹出去就好了。

以下是AC代码:

#include <bits/stdc++.h>
using namespace std;

const int mac=2e5+10;

char s[mac];
vector<int>g[mac];
queue<int>tail1,tail0;

int main(int argc, char const *argv[])
{
	scanf ("%s",s);
	int len=strlen(s);
	int one=0,zero=0;
	for (int i=0; i<len; i++)
		if (s[i]=='0') zero++;
		else one++;
	if (one>=zero) {printf("-1\n"); return 0;}
	int cnt=0,mk=0;
	for (int i=0; i<len; i++){
		if (s[i]=='1' && tail0.empty()) {mk=1; break;}
		else if (s[i]=='1') {
			int v=tail0.front();
			tail0.pop();
			g[v].push_back(i+1);
			tail1.push(v);
		}
		else if (s[i]=='0'){
			if (tail1.empty()) {
				g[++cnt].push_back(i+1); 
				tail0.push(cnt);
				continue;
			}
			int v=tail1.front();
			tail1.pop();
			g[v].push_back(i+1);
			tail0.push(v);
		}
	}
	for (int i=1; i<=cnt; i++)
		if (s[g[i][g[i].size()-1]-1]=='1') {mk=1; break;}
	if (mk) {printf("-1\n"); return 0;};
	printf("%d\n",cnt);
	for (int i=1; i<=cnt; i++){
		printf("%d",g[i].size());
		for (auto x:g[i])
			printf(" %d",x);
		printf("\n");
	}
	return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
CodeForces - 616D是一个关于找到一个序列中最长的第k好子段的起始位置和结束位置的问题。给定一个长度为n的序列和一个整数k,需要找到一个子段,该子段中不超过k个不同的数字。题目要求输出这个序列最长的第k好子段的起始位置和终止位置。 解决这个问题的方法有两种。第一种方法是使用尺取算法,通过维护一个滑动窗口来记录\[l,r\]中不同数的个数。每次如果这个数小于k,就将r向右移动一位;如果已经大于k,则将l向右移动一位,直到个数不大于k。每次更新完r之后,判断r-l+1是否比已有答案更优来更新答案。这种方法的时间复杂度为O(n)。 第二种方法是使用枚举r和双指针的方法。通过维护一个最小的l,满足\[l,r\]最多只有k种数。使用一个map来判断数的种类。遍历序列,如果当前数字在map中不存在,则将种类数sum加一;如果sum大于k,则将l向右移动一位,直到sum不大于k。每次更新完r之后,判断i-l+1是否大于等于y-x+1来更新答案。这种方法的时间复杂度为O(n)。 以上是两种解决CodeForces - 616D问题的方法。具体的代码实现可以参考引用\[1\]和引用\[2\]中的代码。 #### 引用[.reference_title] - *1* [CodeForces 616 D. Longest k-Good Segment(尺取)](https://blog.csdn.net/V5ZSQ/article/details/50750827)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] - *2* [Codeforces616 D. Longest k-Good Segment(双指针+map)](https://blog.csdn.net/weixin_44178736/article/details/114328999)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] [ .reference_list ]

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值